!***********************************************************************
! *** GRID1 ***
!             DEFINE A GEOMETRIA DO DOMINIO DE CALCULO - TUBEIRA BALIGA
!***********************************************************************
      SUBROUTINE GRID1(NIP1,Y,X,L,NG,PI,NI)
      IMPLICIT REAL*8(A-H,O-Z)
      DIMENSION Y(NIP1),X(NIP1)
      REAL*8 L
 
      NG = (NI-2)/2 + 2
      XT=0.05D0
      L=0.1D0
      A1=6.1052D-4
      AT=3.0000D-4
      A2=5.0625D-4
 
      NI1 = NI - 1
      DX = L/(NI-2)
 
      X(1) = - DX
      DO 1 NP = 2, NG-1
        NPW = NP - 1
        X(NP) = X(NPW) + DX
        A = AT + (A1-AT) * (1.D0 - X(NP)/XT) ** 2
    1   Y(NP) = DSQRT(A/PI)
 
      X(NG) = XT
      Y(NG) = DSQRT(AT/PI)
 
      DO 2 NP = NG+1, NI
        NPW = NP - 1
        X(NP) = X(NPW) + DX
        A = AT + (A2-AT) * ((X(NP)-XT)/(L-XT)) ** 2
    2   Y(NP) = DSQRT(A/PI)
 
      Y(1) = Y(2)
      X(NIP1) = X(NI) + DX
      Y(NIP1) = Y(NI)
 
      END

!***********************************************************************
! *** GRID2 ***
!            DEFINE A GEOMETRIA DO DOMINIO DE CALCULO - TUBEIRA SSR/INPE
!***********************************************************************
      SUBROUTINE GRID2(X,Y,NIP1,PI,NG,L6,NI)
      IMPLICIT REAL*8(A-H,O-Z)
      DIMENSION X(NIP1),Y(NIP1)
      REAL*8 L1,L2,L3,L4,L5,L6
 
!     NVKTB = NVK1 + NVK2 + NVK3 + NVK4 + NVK5 + NVK6 = 125 (BASE)
      IFK = (NI - 2)/125
      NVK1 =  8 * IFK
      NVK2 = 13 * IFK
      NVK3 = 16 * IFK
      NVK4 =  3 * IFK
      NVK5 =  1 * IFK
      NVK6 = 84 * IFK
      NG = NVK1 + NVK2 + NVK3 + NVK4 + 2
 
      L1 = 1.000d-3
      L2 = 2.679d-3
      L3 = 4.964d-3
      L4 = 5.300d-3
      L5 = 5.429d-3
      L6 =16.600d-3
 
      RI = 3.350d-3
      RT = 0.500d-3
      RE = 3.500d-3
      RC = 0.500d-3
 
      RL1 = 2.500d-3
      RL2 = 2.702d-3
      RL3 = 0.630d-3
      RL5 = 0.517d-3
 
      ALFA = 42.200d0
      BETA = 14.950d0
      ALFA = ALFA * PI / 180.0d0
      BETA = BETA * PI / 180.0d0
 
! *** X ***
      I = 2
      DX = L1 / NVK1
      X(I) = 0.0d0
      NK1 = NVK1 + 1
      DO 10 I = 3, NK1
   10   X(I) = X(I-1) + DX
      NK2 = NK1 + 1
      X(NK2) = L1
 
      DX = (L2 - L1) / NVK2
      NK3 = NK2 + 1
      NK4 = NK2 + NVK2 - 1
      DO 11 I = NK3, NK4
   11   X(I) = X(I-1) + DX
      NK5 = NK4 + 1
      X(NK5) = L2
 
      DX = (L3 - L2) / NVK3
      NK6 = NK5 + 1
      NK7 = NK5 + NVK3 - 1
      DO 12 I = NK6, NK7
   12   X(I) = X(I-1) + DX
      NK8 = NK7 + 1
      X(NK8) = L3
 
      DX = (L4 - L3)/ NVK4
      NK9 = NK8 + 1
      NK10 = NK8 + NVK4 - 1
      DO 13 I = NK9, NK10
   13   X(I) = X(I-1) + DX
      NK11 = NK10 + 1
      X(NK11) = L4
 
      DX = (L5 - L4)/ NVK5
      NK12 = NK11 + 1
      NK13 = NK11 + NVK5 - 1
      DO 14 I = NK12, NK13
   14   X(I) = X(I-1) + DX
      NK14 = NK13 + 1
      X(NK14) = L5
 
      DX = (L6 - L5) / NVK6
      NK15 = NK14 + 1
      NK16 = NK14 + NVK6 - 1
      DO 15 I = NK15, NK16
   15   X(I) = X(I-1) + DX
      NK17 = NK16 + 1
      X(NK17) = L6
 
! *** Y ***
      Y(2) = RI
      Y(NIP1) = RE
 
      NK1 = NVK1 + 1
      DO 40 I = 3, NK1
   40   Y(I) = RI
      NK2 = NK1 + 1
      Y(NK2) = RI
 
      NK3 = NK2 + 1
      NK4 = NK2 + NVK2 - 1
      DO 41 I = NK3, NK4
        DY = DSQRT( RL1**2 - (X(I)-L1)**2 )
   41   Y(I) = RI - RL1 + DY
      NK5 = NK4 + 1
      Y(NK5) = RL2
 
      NK6 = NK5 + 1
      NK7 = NK5 + NVK3 - 1
      DO 42 I = NK6, NK7
        DY = (X(I) - L2) * DTAN(ALFA)
   42   Y(I) = RL2 - DY
      NK8 = NK7 + 1
      Y(NK8) = RL3
 
      NK9 = NK8 + 1
      NK10 = NK8 + NVK4 - 1
      DO 43 I = NK9, NK10
        DY = DSQRT( RC**2 - (X(I)-L4)**2 )
   43   Y(I) = RT + RC - DY
      NK11 = NK10 + 1
      Y(NK11) = RT
 
      NK12 = NK11 + 1
      NK13 = NK11 + NVK5 - 1
      DO 44 I = NK12, NK13
        DY = DSQRT( RC**2 - (X(I)-L4)**2 )
   44   Y(I) = RT + RC - DY
      NK14 = NK13 + 1
      Y(NK14) = RL5
 
      NK15 = NK14 + 1
      NK16 = NK14 + NVK6 - 1
      DO 45 I = NK15, NK16
        DY = (L6 - X(I)) * DTAN(BETA)
   45   Y(I) = RE - DY
      NK17 = NK16 + 1
      Y(NK17) = RE
 
      END
